"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SolanaChain = void 0;
const web3_js_1 = require("@solana/web3.js");
const connect_sdk_1 = require("@wormhole-foundation/connect-sdk");
const spl_token_1 = require("@solana/spl-token");
class SolanaChain extends connect_sdk_1.ChainContext {
    // Cached objects
    connection;
    constructor(platform, chain) {
        super(platform, chain);
    }
    getRpc() {
        this.connection = this.connection
            ? this.connection
            : this.platform.getRpc(this.chain);
        return this.connection;
    }
    async getTokenAccount(token, address) {
        const tb = await this.getTokenBridge();
        const mintAddress = token === 'native'
            ? await tb.getWrappedNative()
            : token.toUniversalAddress();
        const mint = new web3_js_1.PublicKey(mintAddress.toUint8Array());
        const owner = new web3_js_1.PublicKey(address.toUint8Array());
        const ata = await (0, spl_token_1.getAssociatedTokenAddress)(mint, owner);
        return this.parseAddress(ata.toString());
    }
}
exports.SolanaChain = SolanaChain;
//# sourceMappingURL=chain.js.map