import { PublicKey } from '@solana/web3.js';
import { ChainContext, } from '@wormhole-foundation/connect-sdk';
import { getAssociatedTokenAddress } from '@solana/spl-token';
export class SolanaChain extends ChainContext {
    // Cached objects
    connection;
    constructor(platform, chain) {
        super(platform, chain);
    }
    getRpc() {
        this.connection = this.connection
            ? this.connection
            : this.platform.getRpc(this.chain);
        return this.connection;
    }
    async getTokenAccount(token, address) {
        const tb = await this.getTokenBridge();
        const mintAddress = token === 'native'
            ? await tb.getWrappedNative()
            : token.toUniversalAddress();
        const mint = new PublicKey(mintAddress.toUint8Array());
        const owner = new PublicKey(address.toUint8Array());
        const ata = await getAssociatedTokenAddress(mint, owner);
        return this.parseAddress(ata.toString());
    }
}
//# sourceMappingURL=chain.js.map